import processing.core.*; import processing.serial.*; import interfascia.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; import javax.sound.midi.*; import javax.sound.midi.spi.*; import javax.sound.sampled.*; import javax.sound.sampled.spi.*; import java.util.regex.*; import javax.xml.parsers.*; import javax.xml.transform.*; import javax.xml.transform.dom.*; import javax.xml.transform.sax.*; import javax.xml.transform.stream.*; import org.xml.sax.*; import org.xml.sax.ext.*; import org.xml.sax.helpers.*; public class dsNavConConsole extends PApplet {/* ////////////////////////////////////////////////////////////////////////////
** File:      dsNavConConsole.pde
 VerCon[] = "dsNavConConsolle 0.1.0 by Guiott 02-08";
 Author:    Guido Ottaviani-->g.ottaviani@mediaprogetti.it<--
** Description: navigation control board remote consolle   
**
-------------------------------------------------------------------------------
Copyright 2008 Guido Ottaviani
g.ottaviani@mediaprogetti.it

    dsNavConConsole is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    dsNavConConsole is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with dsNavConConsole.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------    
/////////////////////////////////////////////////////////////////////////////*/



// input text fields
GUIController GuiRun;
IFTextField InputSpeed;
IFTextField InputDist;
IFTextField InputCoordX;
IFTextField InputCoordY;

GUIController GuiConfig;
IFTextField InputSpeed1Kp;
IFTextField InputSpeed1Ki;
IFTextField InputSpeed1Kd;
IFTextField InputSpeed2Kp;
IFTextField InputSpeed2Ki;
IFTextField InputSpeed2Kd;
IFTextField InputAngleKp;
IFTextField InputAngleKi;
IFTextField InputAngleKd;
IFTextField InputDistKp;
IFTextField InputDistKi;
IFTextField InputDistKd;
IFTextField InputAxle;
IFTextField InputKsp1;
IFTextField InputKsp2;
IFTextField InputKvel1;
IFTextField InputKvel2;
IFTextField InputRS232bps;
IFTextField InputRS232Com;

// buttons
ImageButtons BtnQuit;
ImageButtons BtnRS232;
ImageButtons BtnConfig;
ImageButtons BtnRun;
ImageButtons BtnSendSpeed;
ImageButtons BtnSendXY;
ImageButtons BtnSendDist;
ImageButtons BtnSendHalt;
ImageButtons BtnSendReset;
ImageButtons BtnSendVersion;

ImageButtons BtnSendCfgKSpeed1;
ImageButtons BtnSendCfgKSpeed2;
ImageButtons BtnSendCfgKAngle;
ImageButtons BtnSendCfgKDist;
ImageButtons BtnSendCfgWheels;
ImageButtons BtnSendCfgKvel;
ImageButtons BtnSendCfgRS232;
ImageButtons BtnSendCfgSave;
ImageButtons BtnSendCfgLoad;

// other images
PImage bg;
PImage bgConfig;
PImage Grid;
PImage LedRedOn;
PImage LedRedOff;
PImage LedGreenOn;
PImage LedGreenOff;

// gauges
float KnobAngle = -PI/2;
float KnobAngle1 = -PI/2;
int DesSpeed = 0;
int MesSpeed = 0;
float Current = 0;
float DesAngle = 0;
float DesAnglePrev = 0;
float MesAngle = 0;

boolean ConfigFlag = false;
boolean ReleasedFlag = false;

int Cycle = 0;
int CyclePeriod = 333;

int RelX = 432;
int RelY = 397;

int i = 0;
float PrevX = 0;
float PrevY = 0;
float DeltaX = 0;
float DeltaY = 0;
float Xpos = 0;
float Ypos = 0;
float Distance = 0;
float DeltaDist = 0;
float PrevXtmp = 0;      // just for simulation
float PrevYtmp = 0;      // just for simulation

int DesDist = 0;
int DesCoordX = 0;
int DesCoordY = 0;

int TxPeriod = 500;
int TxTimer;
boolean BlinkFlag;
boolean TxFlag = false;

Serial RS232Port;
int RS232ComPort = 99;
int RS232Bps;

String[] StrCfg = new String[19];  // config string
String[] SerialList = new String[0];  // declare an empty string for serial ports list 
byte[] TxBuff = new byte[32];  // Transmission buffer
int TxHeadLen = 4;             // TX header lenght
int[] TxIntValue = new int[8]; // int value buffer

int IdleCount = 0;
int IdleTime = 0;
int IdleTimeP = 0;

float CharTime = (0.2f); // time period in ms for a char sent on RS232

byte[] RxBuff = new byte[32];

int Err = 0;
int HeadLen = 4;    // RX-TX header length

char Ver[] = new char[32];

// it will be set false after RS232 configuration to start real communication
boolean PreInitRS232Flag = true;  

/* in order to allow usage of the applet in a browser as a demo simulation,
   some functions that access to HW resources must me disabled, otherwise a
   security violation error occurs.
*/
boolean SimulationDrawFlag = true;
boolean SimulationCfgFlag = true;
boolean SimulationRS232Flag = true;

/*/////////////////////////////////////////////////////////////////////////////*/

public void setup()
{
  size(1295, 815);
  smooth();
  
  PFont CharFont;
  CharFont = loadFont("HelveticaNeue-Bold-48.vlw"); 
  fill(255,255,255);
  textFont(CharFont, 15); 
  textAlign(CENTER);
  
  bg = loadImage("Panel.gif");
  bgConfig = loadImage("ConfigPanel.gif");
  background(bg);
  LedRedOn = loadImage("LedRedOn.gif");
  LedRedOff = loadImage("LedRedOff.gif");
  LedGreenOn = loadImage("LedGreenOn.gif");
  LedGreenOff = loadImage("LedGreenOff.gif");
  
  DefineButtons();
  
  strokeWeight(3.0f);
  stroke(255,0,0);
 
  InputFieldsDefinition();
  
  LoadCfg();
  
  if (! SimulationRS232Flag)
  {
    i=0;
    while(i< Serial.list().length)
    {
      SerialList = (append(SerialList, Serial.list()[i]));
      i++;
    }
  }
  else
  {
    i=1;
    while(i < 5)
    {
      SerialList = (append(SerialList, "COM"+i));
      i++;
    }
    SerialList = (append(SerialList, "All COM ports are simulated"));
  }
}

// main loop --------------------------------------------------------------------
public void draw()
{ 
  if (ConfigFlag)  // switch panels
  { 
    ButtonsCheckRun();
  }
  else
  {
    ButtonsCheckConfig();
  }
  
  IdleCount++;     // count idle period in ms
  if(IdleCount > 100)
  {
    IdleCount = 0;
    IdleTimeP = millis()-IdleTime;
    IdleTime=millis();
  }
  textAlign(LEFT);
  text(IdleTimeP/100, 1170, 760);
  textAlign(CENTER);
  text(Err, 1240, 760);
  
  if ((millis()-Cycle) > CyclePeriod)  // slow loop start------------------------
  {
    Cycle = millis();
    if (SimulationDrawFlag)          // simulation
    {
      SimulationDrawing();
    }
    else
    {
       Graph(Xpos,Ypos);
    }
    
    if (DesAnglePrev != DesAngle)
    {
      DesAnglePrev = DesAngle;
      TxIntValue[0] = (int)(DesAngle);
      TxData(0, 'O', 1, 1);
    }

    TxData(0, 'A', 0, 3);  // ask for all parameters
    Delay(10);             // wait for data to be received
    
    if (PreInitRS232Flag)
    {
      SimulationRxAll();      // simulation
    }
          
    if (RxData('A',10))
    {// two bytes -> i int
      MesSpeed = ((RxBuff[HeadLen] << 8) + (RxBuff[HeadLen+1]));
      Current = (float)((RxBuff[HeadLen+2] << 8) + (RxBuff[HeadLen+3]));
      Xpos = (float)((RxBuff[HeadLen+4] << 8) + (RxBuff[HeadLen+5]));
      Ypos = (float)((RxBuff[HeadLen+6] << 8) + (RxBuff[HeadLen+7]));
      MesAngle = (float)((RxBuff[HeadLen+8] << 8) + (RxBuff[HeadLen+9]));
      
      Current = abs(DesSpeed*2);                          // just for simulation
      MesSpeed = DesSpeed;                                // just for simulation 
      MesAngle = KnobAngle;                               // just for simulation                     
    }

    if (BlinkFlag)
    {
      BlinkFlag = false;
    }
    else 
    {
      BlinkFlag = true;
    }
  }                                    // slow loop end--------------------------
  
  LedBlink();
}
/*/////////////////////////////////////////////////////////////////////////////*/

/*-----------------------------------------------------------------------------*/
public boolean RxData(char Cmd,int Len)
    {
      byte ChkSum = 0;
      
      if (! PreInitRS232Flag)  // not simulation
      {
        if (RS232Port.available() <= 0)
        {
          println("RX error: Timeout - No data received");
          Err++;
          return false;
        }
        else
        {
          for (i=0; i < Len+HeadLen+1; i++)  // loop for all data expected and only for that
          {
            RxBuff[i] = (byte)(RS232Port.read());
          }
        }
      }
    
      if (RxBuff[0] != '@')
      {
        println("RX error: Header not found. Expected: @  Found: " + (char)(RxBuff[0]));
        Err++;
        return false;
      }
      else if (RxBuff[2] != Cmd)
      {
        println("RX error: Wrong command. Expected: "+Cmd+" Found: " + (char)(RxBuff[2]));
        Err++;
        return false;
      }
      else if (RxBuff[3] != (Len+1))
      {
        println("RX error: Wrong length. Expected: "+ Len+" Found: " + (RxBuff[3]-1));
        Err++;
        return false;
      }
      
      for (i=HeadLen; i < Len+HeadLen; i++)  // loop only for data, header and ChkSum excluded
      {
        ChkSum += RxBuff[i];
      }
      
      if (RxBuff[i] != ChkSum)
      {
        println("RX error: CheckSum error. Expected: "+RxBuff[i] +" Found: " + ChkSum);
        Err++;
        return false;
      }
      else
      {
        return true;
      }
    }
    
/*-----------------------------------------------------------------------------*/
public void Delay(int Bytes)
{
   /* wait for data to be received for a time (in ms) proportional to 
      num of bytes: data bytes + TX overhead + RX overhead (Bytes+5+5)
   */
   Bytes += 10;
   int Del= (int)((CharTime * Bytes) + 0.5f);
   int StartDelay = millis();
   while ((millis()-StartDelay) < Del);
}

/*-----------------------------------------------------------------------------*/
public void LedBlink()
{
  if (BlinkFlag)  // blink green (cycle) led
  {
   image(LedGreenOn,1170,700);
  }
  else
  {
   image(LedGreenOff,1170,700);
  }
    
  if (TxFlag)  // blink red (TX) led
  {
    image(LedRedOn,1230,700);
  }
  else
  {
    image(LedRedOff,1230,700);
    TxTimer = millis();
  }
  if ((millis() - TxTimer) >= TxPeriod)
  {
    TxTimer = millis();
    TxFlag = false;
  }
}

/*-----------------------------------------------------------------------------*/
public void Graph(float Xcoord, float Ycoord)
{
    /* following statements are needed to translate the reference system from
    0(top-left), 750(bottom right) to -5000( bottom-left), +5000(top-right) mm
    */
    pushMatrix();
    translate(RelX,RelY);
    rotate(-HALF_PI);
    strokeWeight(3);
    stroke(255,0,0);
    Xcoord = Xcoord / 10000 * 750;
    Ycoord = Ycoord / 10000 * 750;
    // rotating system switches X with Y
    line(Ycoord, Xcoord, PrevY, PrevX);
    PrevX = Xcoord;
    PrevY = Ycoord;
    popMatrix();
}

/*-----------------------------------------------------------------------------*/  
public int RangeCheckInt(String Data, int Min, int Max)
{
    int IntNum = 0;
    if (Data.length() != 0)
    {
      IntNum = Integer.parseInt(Data);
      if (IntNum < Min) IntNum = Min;
      if (IntNum > Max) IntNum = Max;
    }
    return IntNum;
}

/*-----------------------------------------------------------------------------*/  
public float RangeCheckFloat(String Data, float Min, float Max)
{
    float FloatNum = 0;
    if (Data.length() != 0)
    {
      FloatNum = Float.parseFloat(Data);
      if (FloatNum < Min) FloatNum = Min;
      if (FloatNum > Max) FloatNum = Max;
      TxFlag = true;
    }
    return FloatNum;
}

/*-----------------------------------------------------------------------------*/  
public void TxData(int Id, int Cmd, int ValueLen, int IntFlag)
{
/* Transmit a string toward dsNavCon board
   for a detailed description of protocol, see descrEng.txt in dsODO folder
*/
  int TxBuffCount;
  int ChkSum = 0;
  int CmdLen = 0;
  
  if (IntFlag == 1)  // integer value
  {
    CmdLen = ValueLen*2;          // 1 int value = 2 bytes to transmit
    for (TxBuffCount = 0; TxBuffCount < ValueLen; TxBuffCount++)
    {
      TxBuff[(TxBuffCount*2)+TxHeadLen] = (byte)(TxIntValue[TxBuffCount] >> 8);
      TxBuff[(TxBuffCount*2)+TxHeadLen+1] = (byte)(TxIntValue[TxBuffCount]);
    }
  }
  else if (IntFlag == 2); // long value
  {
    CmdLen = ValueLen*4;        // 1 long value = 4 bytes to transmit
    for (TxBuffCount = 0; TxBuffCount < ValueLen; TxBuffCount++)
    {
      TxBuff[(TxBuffCount*4)+TxHeadLen] = (byte)(TxIntValue[TxBuffCount] >> 24);
      TxBuff[(TxBuffCount*4)+TxHeadLen+1] = (byte)(TxIntValue[TxBuffCount] >> 16);
      TxBuff[(TxBuffCount*4)+TxHeadLen+2] = (byte)(TxIntValue[TxBuffCount] >> 8);
      TxBuff[(TxBuffCount*4)+TxHeadLen+3] = (byte)(TxIntValue[TxBuffCount]);
    }
  }
  
  TxBuff[0] = (byte)('@');
  TxBuff[1] = (byte)(Id);
  TxBuff[2] = (byte)(Cmd);
  TxBuff[3] = (byte)(CmdLen+1);  // included CheckSum

  for (i=0;i<(TxHeadLen+CmdLen);i++) 
  {
   ChkSum += TxBuff[i];
  }
  TxBuff[TxHeadLen+CmdLen] = (byte)(ChkSum);
  
  for (i=0;i<(TxHeadLen+CmdLen+1);i++) 
  {
    if (PreInitRS232Flag)
    {
      println(i + " " + TxBuff[i]);            // simulation
    }
    else
    {
      RS232Port.write(TxBuff[i]);
    }
  }
      
  if (IntFlag != 3) TxFlag = true; // avoid to blink TX led for continuos send
}

/*-----------------------------------------------------------------------------*/
public void LoadCfg()  // Load data from config.txt file
{
  if (! SimulationCfgFlag)
  {
    if (loadStrings("config.txt") != null)
    {
      StrCfg = loadStrings("config.txt");
    }
    else 
    {
      CfgDefault();
      saveStrings("config.txt",StrCfg);
    }
  }
  else
  {
    CfgDefault();
  }
  FillTextFields();
}

/*-----------------------------------------------------------------------------*/
public void CfgDefault()
{//if file config.txt is not present a new one is created with defaults
      StrCfg[0] = "6000";
      StrCfg[1] = "2000";
      StrCfg[2] = "200";
      StrCfg[3] = "6000";
      StrCfg[4] = "2000";
      StrCfg[5] = "200";
      StrCfg[6] = "9999";
      StrCfg[7] = "0";
      StrCfg[8] = "0";
      StrCfg[9] = "9999";
      StrCfg[10] = "0";
      StrCfg[11] = "0";
      StrCfg[12] = "1852222";
      StrCfg[13] = "5061455";
      StrCfg[14] = "5061455";
      StrCfg[15] = "9782453";
      StrCfg[16] = "9782453";
      StrCfg[17] = "57600";
      StrCfg[18] = "1";
}

/*-----------------------------------------------------------------------------*/
public void FillTextFields()
{
       InputSpeed1Kp.setValue(StrCfg[0]);
       InputSpeed1Ki.setValue(StrCfg[1]);
       InputSpeed1Kd.setValue(StrCfg[2]);
       InputSpeed2Kp.setValue(StrCfg[3]);
       InputSpeed2Ki.setValue(StrCfg[4]);
       InputSpeed2Kd.setValue(StrCfg[5]);
       InputAngleKp.setValue(StrCfg[6]);
       InputAngleKi.setValue(StrCfg[7]);
       InputAngleKd.setValue(StrCfg[8]);
       InputDistKp.setValue(StrCfg[9]);
       InputDistKi.setValue(StrCfg[10]);
       InputDistKd.setValue(StrCfg[11]);
       InputAxle.setValue(StrCfg[12]);
       InputKsp1.setValue(StrCfg[13]);
       InputKsp2.setValue(StrCfg[14]);
       InputKvel1.setValue(StrCfg[15]);
       InputKvel2.setValue(StrCfg[16]);
       InputRS232bps.setValue(StrCfg[17]);
       InputRS232Com.setValue(StrCfg[18]);
 }
       
/*-----------------------------------------------------------------------------*/
public void SaveCfg()  // Save current data to config.txt file
{
      StrCfg[0] = InputSpeed1Kp.getValue();
      StrCfg[1] = InputSpeed1Ki.getValue();
      StrCfg[2] = InputSpeed1Kd.getValue();
      StrCfg[3] = InputSpeed2Kp.getValue();
      StrCfg[4] = InputSpeed2Ki.getValue();
      StrCfg[5] = InputSpeed2Kd.getValue();
      StrCfg[6] = InputAngleKp.getValue();
      StrCfg[7] = InputAngleKi.getValue();
      StrCfg[8] = InputAngleKd.getValue();
      StrCfg[9] = InputDistKp.getValue();
      StrCfg[10] = InputDistKi.getValue();
      StrCfg[11] = InputDistKd.getValue();
      StrCfg[12] = InputAxle.getValue();
      StrCfg[13] = InputKsp1.getValue();
      StrCfg[14] = InputKsp2.getValue();
      StrCfg[15] = InputKvel1.getValue();
      StrCfg[16] = InputKvel2.getValue();
      StrCfg[17] = InputRS232bps.getValue();
      StrCfg[18] = InputRS232Com.getValue();
      if (! SimulationCfgFlag)
      {
        saveStrings("config.txt",StrCfg);
      }
}


/*-----------------------------------------------------------------------------*/
public void SimulationDrawing()
{// just for simulation
    DeltaDist = (MesSpeed * CyclePeriod) / 1000; 
    Distance += DeltaDist;
    DeltaX = DeltaDist * (sin(MesAngle + HALF_PI));
    DeltaY = DeltaDist * (cos(MesAngle + HALF_PI));
    Graph(DeltaX+PrevXtmp,DeltaY+PrevYtmp);
    PrevXtmp = DeltaX+PrevXtmp;
    PrevYtmp = DeltaY+PrevYtmp;
}

public void SimulationRxAll()
{
// just for simulation      
      RxBuff[0] = '@';
      RxBuff[1] = 0;
      RxBuff[2] = 'A';
      RxBuff[3] = 11;
      RxBuff[4] = 1;
      RxBuff[5] = 2;
      RxBuff[6] = 3;
      RxBuff[7] = 4;
      RxBuff[8] = 5;
      RxBuff[9] = 6;
      RxBuff[10] = 7;
      RxBuff[11] = 8;
      RxBuff[12] = 10;
      RxBuff[13] = 10;
      RxBuff[14] = 56;
}

public void SimulationRxVer()
{
// just for simulation      
      RxBuff[0] = '@';
      RxBuff[1] = 0;
      RxBuff[2] = 'R';
      RxBuff[3] = 28;
      RxBuff[4] = 'd';
      RxBuff[5] = 's';
      RxBuff[6] = 'O';
      RxBuff[7] = 'D';
      RxBuff[8] = 'O';
      RxBuff[9] = ' ';
      RxBuff[10] ='1';
      RxBuff[11] ='.';
      RxBuff[12] ='0';
      RxBuff[13] ='.';
      RxBuff[14] ='0';
      RxBuff[15] =' ';
      RxBuff[16] ='b';
      RxBuff[17] ='y';
      RxBuff[18] =' ';
      RxBuff[19] ='G';
      RxBuff[20] ='u';
      RxBuff[21] ='i';
      RxBuff[22] ='o';
      RxBuff[23] ='t';
      RxBuff[24] ='t';
      RxBuff[25] =' ';
      RxBuff[26] ='0';
      RxBuff[27] ='2';
      RxBuff[28] ='-';
      RxBuff[29] ='0';
      RxBuff[30] ='8';
      RxBuff[31] =116;
}

/*-----------------------------------------------------------------------------*/
public void DefineButtons()
{
 // Define and create image button for RUN panel
  PImage b = loadImage("BtnConfigN.gif");
  PImage r = loadImage("BtnConfigO.gif");
  PImage d = loadImage("BtnConfigP.gif");
  int x = 845;
  int y = 765; 
  int w = b.width;
  int h = b.height;
  BtnConfig = new ImageButtons(x, y, w, h, b, r, d);
  
  PImage b2 = loadImage("BtnQuitN.gif");
  PImage r2 = loadImage("BtnQuitO.gif");
  PImage d2 = loadImage("BtnQuitP.gif");
  int x2 = 945;
  int y2 = 765; 
  int w2 = b.width;
  int h2 = b.height;
  BtnQuit = new ImageButtons(x2, y2, w2, h2, b2, r2, d2);
  
  PImage b4 = loadImage("BtnRunN.gif");
  PImage r4 = loadImage("BtnRunO.gif");
  PImage d4 = loadImage("BtnRunP.gif");
  int x4 = 845;
  int y4 = 765; 
  int w4 = b.width;
  int h4 = b.height;
  BtnRun = new ImageButtons(x4, y4, w4, h4, b4, r4, d4);

  PImage b3 = loadImage("BtnSendN.gif");
  PImage r3 = loadImage("BtnSendO.gif");
  PImage d3 = loadImage("BtnSendP.gif");
  int x3 = 1170;
  int y3 = 500; 
  int w3 = b.width;
  int h3 = b.height;
  BtnSendSpeed = new ImageButtons(x3, y3, w3, h3, b3, r3, d3);
  
  PImage b6 = loadImage("BtnSendN.gif");
  PImage r6 = loadImage("BtnSendO.gif");
  PImage d6 = loadImage("BtnSendP.gif");
  int x6 = 1170;
  int y6 = 550; 
  int w6 = b.width;
  int h6 = b.height;
  BtnSendDist = new ImageButtons(x6, y6, w6, h6, b6, r6, d6);

  PImage b5 = loadImage("BtnSendN.gif");
  PImage r5 = loadImage("BtnSendO.gif");
  PImage d5 = loadImage("BtnSendP.gif");
  int x5 = 1170;
  int y5 = 600; 
  int w5 = b.width;
  int h5 = b.height;
  BtnSendXY = new ImageButtons(x5, y5, w5, h5, b5, r5, d5);
 
  PImage b7 = loadImage("BtnVersionN.gif");
  PImage r7 = loadImage("BtnVersionO.gif");
  PImage d7 = loadImage("BtnVersionP.gif");
  int x7 = 1170;
  int y7 = 650; 
  int w7 = b.width;
  int h7 = b.height;
  BtnSendVersion = new ImageButtons(x7, y7, w7, h7, b7, r7, d7);

  PImage b8 = loadImage("BtnHaltN.gif");
  PImage r8 = loadImage("BtnHaltO.gif");
  PImage d8 = loadImage("BtnHaltP.gif");
  int x8 = 845;
  int y8 = 715; 
  int w8 = b.width;
  int h8 = b.height;
  BtnSendHalt = new ImageButtons(x8, y8, w8, h8, b8, r8, d8);

  PImage b9 = loadImage("BtnResetN.gif");
  PImage r9 = loadImage("BtnResetO.gif");
  PImage d9 = loadImage("BtnResetP.gif");
  int x9 = 945;
  int y9 = 715; 
  int w9 = b.width;
  int h9 = b.height;
  BtnSendReset = new ImageButtons(x9, y9, w9, h9, b9, r9, d9);
  
  
  
  // Define and create image button for Config panel 
  PImage b10 = loadImage("BtnSendN.gif");
  PImage r10 = loadImage("BtnSendO.gif");
  PImage d10 = loadImage("BtnSendP.gif");
  int x10 = 1190;
  int y10 = 48; 
  int w10 = b.width;
  int h10 = b.height;
  BtnSendCfgKSpeed1 = new ImageButtons(x10, y10, w10, h10, b10, r10, d10);
  
  PImage b11 = loadImage("BtnSendN.gif");
  PImage r11 = loadImage("BtnSendO.gif");
  PImage d11 = loadImage("BtnSendP.gif");
  int x11 = 1190;
  int y11 = 98; 
  int w11 = b.width;
  int h11 = b.height;
  BtnSendCfgKSpeed2 = new ImageButtons(x11, y11, w11, h11, b11, r11, d11);
  
  PImage b12 = loadImage("BtnSendN.gif");
  PImage r12 = loadImage("BtnSendO.gif");
  PImage d12 = loadImage("BtnSendP.gif");
  int x12 = 1190;
  int y12 = 148; 
  int w12 = b.width;
  int h12 = b.height;
  BtnSendCfgKAngle = new ImageButtons(x12, y12, w12, h12, b12, r12, d12);
  
  PImage b13 = loadImage("BtnSendN.gif");
  PImage r13 = loadImage("BtnSendO.gif");
  PImage d13 = loadImage("BtnSendP.gif");
  int x13 = 1190;
  int y13 = 198; 
  int w13 = b.width;
  int h13 = b.height;
  BtnSendCfgKDist = new ImageButtons(x13, y13, w13, h13, b13, r13, d13);
  
  PImage b14 = loadImage("BtnSendN.gif");
  PImage r14 = loadImage("BtnSendO.gif");
  PImage d14 = loadImage("BtnSendP.gif");
  int x14 = 1190;
  int y14 = 258; 
  int w14 = b.width;
  int h14 = b.height;
  BtnSendCfgWheels = new ImageButtons(x14, y14, w14, h14, b14, r14, d14);
  
  PImage b18 = loadImage("BtnSendN.gif");
  PImage r18 = loadImage("BtnSendO.gif");
  PImage d18 = loadImage("BtnSendP.gif");
  int x18 = 1190;
  int y18 = 313; 
  int w18 = b.width;
  int h18 = b.height;
  BtnSendCfgKvel = new ImageButtons(x18, y18, w18, h18, b18, r18, d18);
  
  PImage b15 = loadImage("BtnSendN.gif");
  PImage r15 = loadImage("BtnSendO.gif");
  PImage d15 = loadImage("BtnSendP.gif");
  int x15 = 1190;
  int y15 = 368; 
  int w15 = b.width;
  int h15 = b.height;
  BtnSendCfgRS232 = new ImageButtons(x15, y15, w15, h15, b15, r15, d15);
  
  PImage b16 = loadImage("BtnLoadN.gif");
  PImage r16 = loadImage("BtnLoadO.gif");
  PImage d16 = loadImage("BtnLoadP.gif");
  int x16 = 845;
  int y16 = 715; 
  int w16 = b.width;
  int h16 = b.height;
  BtnSendCfgLoad = new ImageButtons(x16, y16, w16, h16, b16, r16, d16);

  PImage b17 = loadImage("BtnSaveN.gif");
  PImage r17 = loadImage("BtnSaveO.gif");
  PImage d17 = loadImage("BtnSaveP.gif");
  int x17 = 945;
  int y17 = 715; 
  int w17 = b.width;
  int h17 = b.height;
  BtnSendCfgSave = new ImageButtons(x17, y17, w17, h17, b17, r17, d17);
}

/*-----------------------------------------------------------------------------*/
public void InputFieldsDefinition()
{
  // Define and create input fields for Main panel 
  GuiRun = new GUIController(this);
  InputSpeed = new IFTextField("", 1043, 503, 67);
  InputSpeed.addActionListener(this);
  GuiRun.add(InputSpeed);
  
  InputDist = new IFTextField("", 1043, 553, 67);
  InputDist.addActionListener(this);
  GuiRun.add(InputDist);
  
  InputCoordY = new IFTextField("", 1043, 603, 67);
  InputCoordY.addActionListener(this);
  GuiRun.add(InputCoordY);

  InputCoordX = new IFTextField("", 923, 603, 67);
  InputCoordX.addActionListener(this);
  GuiRun.add(InputCoordX);
  
  int YbaseInputFields = 53;
  int XbaseInputFields = 893;
  
  // Define and create input fields for Config panel 
  GuiConfig = new GUIController(this);
  InputSpeed1Kp = new IFTextField("", XbaseInputFields, YbaseInputFields, 73);
  InputSpeed1Kp.addActionListener(this);
  
  InputSpeed1Ki = new IFTextField("", XbaseInputFields+100, YbaseInputFields, 73);
  InputSpeed1Ki.addActionListener(this);

  InputSpeed1Kd = new IFTextField("", XbaseInputFields+200, YbaseInputFields, 73);
  InputSpeed1Kd.addActionListener(this);

  InputSpeed2Kp = new IFTextField("", XbaseInputFields, YbaseInputFields+50, 73);
  InputSpeed2Kp.addActionListener(this);
  
  InputSpeed2Ki = new IFTextField("", XbaseInputFields+100, YbaseInputFields+50, 73);
  InputSpeed2Ki.addActionListener(this);

  InputSpeed2Kd = new IFTextField("", XbaseInputFields+200, YbaseInputFields+50, 73);
  InputSpeed2Kd.addActionListener(this);

  InputAngleKp = new IFTextField("", XbaseInputFields, YbaseInputFields+100, 73);
  InputAngleKp.addActionListener(this);
  
  InputAngleKi = new IFTextField("", XbaseInputFields+100, YbaseInputFields+100, 73);
  InputAngleKi.addActionListener(this);

  InputAngleKd = new IFTextField("", XbaseInputFields+200, YbaseInputFields+100, 73);
  InputAngleKd.addActionListener(this);

  InputDistKp = new IFTextField("", XbaseInputFields, YbaseInputFields+150, 73);
  InputDistKp.addActionListener(this);
  
  InputDistKi = new IFTextField("", XbaseInputFields+100, YbaseInputFields+150, 73);
  InputDistKi.addActionListener(this);

  InputDistKd = new IFTextField("", XbaseInputFields+200, YbaseInputFields+150, 73);
  InputDistKd.addActionListener(this);

  InputAxle = new IFTextField("", XbaseInputFields, YbaseInputFields+210, 73);
  InputAxle.addActionListener(this);

  InputKsp1 = new IFTextField("", XbaseInputFields+100, YbaseInputFields+210, 73);
  InputKsp1.addActionListener(this);

  InputKsp2 = new IFTextField("", XbaseInputFields+200, YbaseInputFields+210, 73);
  InputKsp2.addActionListener(this);

  InputKvel1 = new IFTextField("", XbaseInputFields+100, YbaseInputFields+265, 73);
  InputKvel1.addActionListener(this);

  InputKvel2 = new IFTextField("", XbaseInputFields+200, YbaseInputFields+265, 73);
  InputKvel2.addActionListener(this);
  
  InputRS232bps = new IFTextField("", XbaseInputFields+100, YbaseInputFields+320, 73);
  InputRS232bps.addActionListener(this);

  InputRS232Com = new IFTextField("", XbaseInputFields+200, YbaseInputFields+320, 73);
  InputRS232Com.addActionListener(this);
}

/*-----------------------------------------------------------------------------*/
public void InputFieldsRun()   // input fields for Main panel 
{
  GuiConfig.remove(InputSpeed1Kp);
  GuiConfig.remove(InputSpeed1Ki);
  GuiConfig.remove(InputSpeed1Kd);
  
  GuiConfig.remove(InputSpeed2Kp);
  GuiConfig.remove(InputSpeed2Ki);
  GuiConfig.remove(InputSpeed2Kd);
 
  GuiConfig.remove(InputAngleKp);
  GuiConfig.remove(InputAngleKi);
  GuiConfig.remove(InputAngleKd);
  
  GuiConfig.remove(InputDistKp);
  GuiConfig.remove(InputDistKi);
  GuiConfig.remove(InputDistKd);

  GuiConfig.remove(InputAxle);
  GuiConfig.remove(InputKsp1);
  GuiConfig.remove(InputKsp2);
  
  GuiConfig.remove(InputKvel1);
  GuiConfig.remove(InputKvel2);

  
  GuiConfig.remove(InputRS232bps);
  GuiConfig.remove(InputRS232Com);
  
  
  GuiRun.add(InputSpeed);
  GuiRun.add(InputDist);
  GuiRun.add(InputCoordX);
  GuiRun.add(InputCoordY);
}

/*-----------------------------------------------------------------------------*/
public void InputFieldsConfig()    // input fields for Config panel 
{
  GuiRun.remove(InputSpeed);
  GuiRun.remove(InputDist);
  GuiRun.remove(InputCoordX);
  GuiRun.remove(InputCoordY);
 
 
  GuiConfig.add(InputSpeed1Kp);
  GuiConfig.add(InputSpeed1Ki);
  GuiConfig.add(InputSpeed1Kd);
  
  GuiConfig.add(InputSpeed2Kp);
  GuiConfig.add(InputSpeed2Ki);
  GuiConfig.add(InputSpeed2Kd);
  
  GuiConfig.add(InputAngleKp);
  GuiConfig.add(InputAngleKi);
  GuiConfig.add(InputAngleKd);
  
  GuiConfig.add(InputDistKp);
  GuiConfig.add(InputDistKi);
  GuiConfig.add(InputDistKd);

  GuiConfig.add(InputAxle);
  GuiConfig.add(InputKsp1);
  GuiConfig.add(InputKsp2);
  
  GuiConfig.add(InputKvel1);
  GuiConfig.add(InputKvel2);
  
  GuiConfig.add(InputRS232bps);
  GuiConfig.add(InputRS232Com);
}

/*-----------------------------------------------------------------------------*/  
public void actionPerformed(GUIEvent e)   // an event on input fields
{
  if (e.getMessage().equals("Completed"))
  {
    //SendSpeed();
  }
}

/*-----------------------------------------------------------------------------*/
public void mouseReleased()
{      
  ReleasedFlag = true;
}

/*-----------------------------------------------------------------------------*/
class Button 
{
  int x, y;
  int w, h;
  int basecolor, highlightcolor;
  int currentcolor;
  boolean over = false;
  boolean pressed = false;   
  boolean released = false;   
    
  public void pressed() {
    if(over && mousePressed) {
      pressed = true;
    } else {
      pressed = false;
    }    
  }
    
  public void released() {
    if(over && ReleasedFlag) {
      released = true;
      ReleasedFlag = false;
    } else {
      released = false;
    }    
  }

  public boolean overRect(int x, int y, int width, int height) {
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}
}

class ImageButtons extends Button 
{
  PImage base;
  PImage roll;
  PImage down;
  PImage currentimage;

  ImageButtons(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;
    base = ibase;
    roll = iroll;
    down = idown;
    currentimage = base;
  }
  
  public void update() 
  {
    over();
    pressed();
    released();
    if(pressed) {
      currentimage = down;
    } else if (over){
      currentimage = roll;
    } else {
      currentimage = base;
    }
  }
  
  public void over() 
  {
    if( overRect(x, y, w, h) ) {
      over = true;
    } else {
      over = false;
    }
  }
  
  public void display() 
  {
    image(currentimage, x, y);
  }
}

/*-----------------------------------------------------------------------------*/  
public void ButtonsCheckConfig()  // Main panel controls
{
    Grid = get(57,21,751,751);
    background(bg);
    image(Grid,57,21);

    BtnConfig.update();
    if (BtnConfig.released)
    {
      ConfigFlag = true;
      InputFieldsConfig();
    }
    BtnConfig.display();
    
    BtnQuit.update();
    if (BtnQuit.released)
    {

      exit();
    }
    BtnQuit.display();
    
    BtnSendSpeed.update();
    if (BtnSendSpeed.released)
    {
      // 1 int (range -500 mm/s +500 mm/s)
      DesSpeed = RangeCheckInt(InputSpeed.getValue(), -500, 500);
      InputSpeed.setValue(nf(DesSpeed,3));
      TxIntValue[0] = DesSpeed;
      TxData(0, 'W', 1, 1);
    }
    BtnSendSpeed.display();
    
    BtnSendXY.update();
    if (BtnSendXY.released)
    {
      //2 int ( X, Y) (range -5000 mm +5000 mm)
      DesCoordX = RangeCheckInt(InputCoordX.getValue(), -5000, 5000);
      InputCoordX.setValue(nf(DesCoordX,4));
      DesCoordY = RangeCheckInt(InputCoordY.getValue(), -5000, 5000);
      InputCoordY.setValue(nf(DesCoordY,4));
      TxIntValue[0] = DesCoordX;
      TxIntValue[1] = DesCoordY;
      TxData(0, 'x', 2, 1);
    }
    BtnSendXY.display();
    
    BtnSendDist.update();
    if (BtnSendDist.released)
    {
      // 1 int (range -5000 mm + 5000 mm)
      DesDist = RangeCheckInt(InputDist.getValue(), -5000, 50000);
      InputDist.setValue(nf(DesDist,4));
      TxIntValue[0] = DesDist;
      TxData(0, 'D', 1, 1);
    }
    BtnSendDist.display();
    
    BtnSendReset.update();
    if (BtnSendReset.released)
    {
      TxData(0, '*', 0, 1);
    }
    BtnSendReset.display();
    
    BtnSendHalt.update();
    if (BtnSendHalt.released)
    {
      TxData(0, 'H', 0, 1);
    }
    BtnSendHalt.display();
    
    BtnSendVersion.update();
    if (BtnSendVersion.released)
    {
      int VerLen = 27;
      TxData(0, 'R', 0, 1);  // ask for all parameters
      Delay(VerLen);         // wait for data to be received
      
      if (PreInitRS232Flag)
      {
        SimulationRxVer();      // simulation
      }
    
      if (RxData('R',VerLen))
      {
        for (i=HeadLen; i < VerLen+HeadLen; i++)
        {
          Ver[i-HeadLen]= (char)(RxBuff[i]);
        }
      }
    }
    textAlign(RIGHT);
    String VerS = new String(Ver);
    text(VerS, 1148, 672); 
    BtnSendVersion.display();
    
    KnobSegment(); 
    GaugeAngle();
    GaugeSpeed();
    GaugeCurrent();
    ReleasedFlag = false;
}

/*-----------------------------------------------------------------------------*/
public void ButtonsCheckRun()  // Config panel controls
{
    int Kp;
    int Ki;
    int Kd;
    int K;
    
    Grid = get(57,21,751,751);
    background(bgConfig);
    image(Grid,57,21);
    BtnRun.display();
    BtnRun.update();
    
    BtnQuit.update();
    if (BtnQuit.released)
    {
      exit();
    }
    BtnQuit.display();

    if (BtnRun.released)  
    {
      ConfigFlag = false;
      InputFieldsRun();
    }
    BtnRun.display();
    
    BtnSendCfgKSpeed1.update();
    if (BtnSendCfgKSpeed1.released)
    {
      // 3 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputSpeed1Kp.getValue(), 0, 9999);
      InputSpeed1Kp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputSpeed1Ki.getValue(), 0, 9999);
      InputSpeed1Ki.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputSpeed1Kd.getValue(), 0, 9999);
      InputSpeed1Kd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      TxData(1, 'K', 3, 1);
    }
    BtnSendCfgKSpeed1.display();
    
    BtnSendCfgKSpeed2.update();
    if (BtnSendCfgKSpeed2.released)
    {
      // 3 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputSpeed2Kp.getValue(), 0, 9999);
      InputSpeed2Kp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputSpeed2Ki.getValue(), 0, 9999);
      InputSpeed2Ki.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputSpeed2Kd.getValue(), 0, 9999);
      InputSpeed2Kd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      TxData(2, 'K', 3, 1);
    }
    BtnSendCfgKSpeed2.display();
    
    BtnSendCfgKAngle.update();
    if (BtnSendCfgKAngle.released)
    {
      // 3 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputAngleKp.getValue(), 0, 9999);
      InputAngleKp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputAngleKi.getValue(), 0, 9999);
      InputAngleKi.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputAngleKd.getValue(), 0, 9999);
      InputAngleKd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      TxData(0, 'k', 3, 1);
    }
    BtnSendCfgKAngle.display();
    
    BtnSendCfgKDist.update();
    if (BtnSendCfgKDist.released)
    {
      // 3 int K x 10.000 (range 0 +9999)
      Kp = RangeCheckInt(InputDistKp.getValue(), 0, 9999);
      InputDistKp.setValue(nf(Kp,0));
      Ki = RangeCheckInt(InputDistKi.getValue(), 0, 9999);
      InputDistKi.setValue(nf(Ki,0));
      Kd = RangeCheckInt(InputDistKd.getValue(), 0, 9999);
      InputDistKd.setValue(nf(Kd,0));
      TxIntValue[0] = Kp;
      TxIntValue[1] = Ki;
      TxIntValue[2] = Kd;
      TxData(0, 'J', 3, 1);
    }
    BtnSendCfgKDist.display();
    
    BtnSendCfgWheels.update();
    if (BtnSendCfgWheels.released)
    {
      /* Axle size (micron / 10) 
         Ksp = constants for traveled distance calculation: 
         SPACE_ENC_4X (micron / 1.000.000 = picoM)
         3 long 
      */
      K = RangeCheckInt(InputAxle.getValue(), 0, 9999999);
      InputAxle.setValue(nf(K,0));
      TxIntValue[0] = K;
      
      K = RangeCheckInt(InputKsp1.getValue(), 0, 9999999);
      InputKsp1.setValue(nf(K,0));
      TxIntValue[1] = K;
      
      K = RangeCheckInt(InputKsp2.getValue(), 0, 9999999);
      InputKsp2.setValue(nf(K,0));
      TxIntValue[2] = K;
      
      TxData(0, 'M', 3, 2);
    }
    BtnSendCfgWheels.display();
    
    BtnSendCfgKvel.update();
    if (BtnSendCfgKvel.released)
    {
      /* Speed calculation K in micron/second = 298536736
	 Speed calculation K in m/s as a power of 2 to semplify dsPID elaboration
	 Kvel[] << 15 ( x 2^15) 
         2 long, 2 x 4 bytes
         for a detailde description see descrEng.txt in dsODO folder
      */
      K = RangeCheckInt(InputKvel1.getValue(), 0, 9999999);
      InputKvel1.setValue(nf(K,0));
      TxIntValue[0] = K;
      TxData(1, 'L', 1, 2);
      K = RangeCheckInt(InputKvel2.getValue(), 0, 9999999);
      InputKvel2.setValue(nf(K,0));
      TxIntValue[0] = K;
      TxData(2, 'L', 1, 2);
    }
    BtnSendCfgKvel.display();

      textAlign(LEFT);
      text("Available COM ports:",850,430);
      for(i=0;i<(SerialList.length);i++)
      {
        if (i == RS232ComPort)
        {
          fill(0,100,255);
        }
        else
        {
          fill(255,255,255);
        }
        text(i + " = " + SerialList[i],860,450 + (i*20));
      }
      fill(255,255,255);
    
    BtnSendCfgRS232.update();
    if (BtnSendCfgRS232.released)
    {
       RS232ComPort = RangeCheckInt(InputRS232Com.getValue(), 0, SerialList.length-1);
       RS232Bps = RangeCheckInt(InputRS232bps.getValue(), 1200, 115200);
       try
       { 
          if (! SimulationRS232Flag)
          {
            RS232Port = new Serial(this, Serial.list()[RS232ComPort], RS232Bps);
            PreInitRS232Flag = false;          // turn ON real RS232 sending
          }
          else
          {
            PreInitRS232Flag = true;          // still in simulation
          }
          CharTime = (115200 / RS232Bps) * 0.1f; // waiting time is a function of bps
        }
        catch(Exception e)    // not a valid COM port
        {
          RS232ComPort = 99;
          PreInitRS232Flag = true;          // turn OFF real RS232 sending
        } 

       InputRS232Com.setValue(nf(RS232ComPort,0));
       InputRS232bps.setValue(nf(RS232Bps,0));
    }
    BtnSendCfgRS232.display();
    
    BtnSendCfgLoad.update();
    if (BtnSendCfgLoad.released)
    {
      LoadCfg();
    }
    BtnSendCfgLoad.display();
    
    BtnSendCfgSave.update();
    if (BtnSendCfgSave.released)
    {
      SaveCfg();
    }
    BtnSendCfgSave.display();
    
    ReleasedFlag = false;
}

/*-----------------------------------------------------------------------------*/
public void KnobSegment()  // draw knob index
{
  float KnobX = 1162;
  float KnobY = 333;
  float KnobSegLength = 50;
  float KnobDx = mouseX - KnobX;
  float KnobDy = mouseY - KnobY;
  int Base = 3;
  pushMatrix();
  translate(KnobX, KnobY);
  if (mouseX >= KnobX-KnobSegLength && mouseX <= KnobX+KnobSegLength && 
      mouseY >= KnobY-KnobSegLength && mouseY <= KnobY+KnobSegLength &&
      mousePressed)
    {
      KnobAngle = atan2(KnobDy, KnobDx);  
    }
   rotate(KnobAngle);
   strokeWeight(7.0f);
   stroke(67,85,100);
   triangle(0,-Base,0,Base,KnobSegLength,0);
   popMatrix();
   KnobAngle1=degrees(KnobAngle+(PI/2));
   textAlign(CENTER);
   text(nf(KnobAngle1,0,1), KnobX,KnobY+115);
   DesAngle = KnobAngle1;
}

/*-----------------------------------------------------------------------------*/
public void GaugeAngle()
{
  float GaugeX = 950;
  float GaugeY = 333;
  float GaugeSegLength = 60;
  float Angle1 = 0;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
   rotate(MesAngle);
   strokeWeight(3.0f);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   Angle1 = degrees(MesAngle+(PI/2));
   textAlign(CENTER);
   text(nf(Angle1,0,1), GaugeX,GaugeY+112);
}

/*-----------------------------------------------------------------------------*/
public void GaugeSpeed()
{
  float GaugeX = 950;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Speed1;
  float MinSpeed=-500;
  float MaxSpeed=500;
  float Speed = 0;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Speed = MesSpeed;
  if (Speed > 500) Speed = 500;
  if (Speed < -500) Speed = -500;
  Speed1 = Speed * (300 / (MaxSpeed-MinSpeed));
  Speed1=radians(Speed1-90);
   rotate((Speed1));
   strokeWeight(3.0f);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(Speed,0,1), GaugeX,GaugeY+105);
}

/*-----------------------------------------------------------------------------*/
public void GaugeCurrent()
{
  float GaugeX = 1168;
  float GaugeY = 112;
  float GaugeSegLength = 60;
  float Current1 = 0;
  float MinCurrent=0;
  float MaxCurrent=1000;
  int Base = 2;
  pushMatrix();
  translate(GaugeX, GaugeY);
  Current1 = Current * (300 / (MaxCurrent-MinCurrent));
  Current1 = radians(Current1-240);
   rotate((Current1));
   strokeWeight(3.0f);
   stroke(255,0,0);
   triangle(15,-Base,15,Base,GaugeSegLength,0);
   popMatrix();
   textAlign(CENTER);
   text(nf(Current,0,1), GaugeX,GaugeY+105);
}

  static public void main(String args[]) {     PApplet.main(new String[] { "dsNavConConsole" });  }}